src/config/urls.py
from django.conf.urls.static import static
from django.contrib import admin
from django.urls import path, include
from django.views.generic.base import TemplateView

from accounts.views import send_email
from config import settings

urlpatterns = [
    path("admin/", admin.site.urls),
    path("__debug__/", include("debug_toolbar.urls")),
    path("accounts/", include("accounts.urls")),
    path("accounts/", include("django.contrib.auth.urls")),
    path("", TemplateView.as_view(template_name="index.html"), name="index"),
    path("", include("base_app.urls")),
    path("", include("students.urls")),
    path("", include("teachers.urls")),
    path("", include("groups.urls")),
    path("send-test-email/", send_email, name="send_email"),
    path("oauth/", include("social_django.urls", namespace="social")),
    path("accounts/", include("django.contrib.auth.urls")),
]

if settings.DEBUG:
    urlpatterns += static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

# handler404 = "students.views.custom_404"
# handler404 = "Custom404View.as_view()"

src/groups/urls.py
from django.urls import path

from .views import IndexView, AllGroups, UpdateGroupView, DeleteGroup, CreateGroupView

app_name = "groups"

urlpatterns = [
    path("", IndexView.as_view(), name="index"),
    path("groups/", AllGroups.as_view(), name="groups"),
    path("groups/create/", CreateGroupView.as_view(), name="create_group"),
    path("groups/update/<int:pk>/", UpdateGroupView.as_view(), name="update_group"),
    path("groups/delete/<int:pk>/", DeleteGroup.as_view(), name="delete_group"),
]

src/groups/models.py
import random

from django.core.validators import MinLengthValidator
from django.db import models
from faker import Faker

from groups.utils.validators import name_of_curator_validator


# from students.models import Person


class Group(models.Model):
    name_of_curator = models.CharField(
        max_length=120,
        blank=True,
        null=True,
        validators=[MinLengthValidator(1), name_of_curator_validator],
    )
    name_of_teacher = models.CharField(max_length=120)
    group_name = models.CharField(max_length=50)
    quantity_of_students = models.PositiveSmallIntegerField(
        default=20, null=True, blank=True
    )
    start_date = models.DateField(null=True)

    def __str__(self):
        return (
            f"Куратор:{self.name_of_curator} викладач: {self.name_of_teacher}, \n"
            f"дата початку - {self.start_date}, спеціалізація - {self.group_name}"
        )

    @classmethod
    def generate_instances(cls, count):
        fake = Faker()
        for _ in range(count):
            list_of_specialities = ["Python", "Java", "QA"]
            Group.objects.create(
                name_of_curator=fake.name(),
                name_of_teacher=fake.name(),
                group_name=random.choice(list_of_specialities),
                quantity_of_students=random.randint(10, 15),
                start_date=fake.date_this_year(),
            )

src/groups/forms.py
from django.core.exceptions import ValidationError
from django.forms import ModelForm

from .models import Group


class GroupForm(ModelForm):
    class Meta:
        model = Group
        fields = (
            "name_of_curator",
            "name_of_teacher",
            "quantity_of_students",
            "group_name",
        )

    @staticmethod
    def normalize_text(text: str):
        return text.strip().capitalize()

    def clean_name_of_curator(self):
        return self.normalize_text(self.cleaned_data["name_of_curator"])

    def clean_name_of_teacher(self):
        return self.normalize_text(self.cleaned_data["name_of_teacher"])

    def clean(self):
        cleaned_data = super().clean()

        name_of_curator = cleaned_data["name_of_curator"]
        name_of_teacher = cleaned_data["name_of_teacher"]

        if name_of_curator == name_of_teacher:
            raise ValidationError("Curator can't be teacher!")
        return cleaned_data

src/groups/views.py
from django.contrib.auth.mixins import LoginRequiredMixin
from django.urls import reverse_lazy
from django.views.generic import (
    TemplateView,
    ListView,
    CreateView,
    UpdateView,
    DeleteView,
)

from .forms import GroupForm
from .models import Group


class IndexView(TemplateView):
    template_name = "index.html"
    extra_context = {"key": "guys", "site_name": "LMS"}

    def get_context_data(self, **kwargs):
        context = super().get_context_data()
        context["my_name"] = "Oleg"
        return context


class AllGroups(LoginRequiredMixin, ListView):
    model = Group
    template_name = "groups/list.html"
    context_object_name = "groups"


class CreateGroupView(LoginRequiredMixin, CreateView):
    template_name = "groups/create.html"
    form_class = GroupForm
    model = Group
    # fields = ("first_name", "last_name", "email", "group_name")
    success_url = reverse_lazy("students:create_student")


class UpdateGroupView(LoginRequiredMixin, UpdateView):
    template_name = "groups/update.html"
    context_object_name = "groups"
    form_class = GroupForm
    pk_url_kwarg = "pk"
    queryset = Group.objects.filter()
    success_url = reverse_lazy("groups: groups")


class DeleteGroup(LoginRequiredMixin, DeleteView):
    template_name = "groups/delete.html"
    context_object_name = "groups"
    form_class = GroupForm
    pk_url_kwarg = "pk"
    queryset = Group.objects.filter()
    success_url = reverse_lazy("groups:groups")

src/templates/groups/create.html
  {% extends "index.html" %}
{% load crispy_forms_tags %}

{% block content %}
    <form method='POST' style="width: 25em; margin: auto">
        {{ form|crispy }}
        <button type="submit" class="btn btn-success" value="Create">Create group</button>
    </form>
{% endblock content %}

src/templates/groups/delete.html
{% extends "index.html" %}
{% load crispy_forms_tags %}

{% block content %}
    <form method='POST' style="width: 25em; margin: auto">
        {{ form|crispy }}
        <button type="submit" class="btn btn-success" value="delete">Delete group</button>
    </form>
{% endblock content %}

src/templates/groups/list.html
{% extends "index.html" %}

{% block content %}

    <table class="table table-dark table-striped">
        <thead>
        <tr>
            <th scope="col">#</th>
            <th scope="col">Curators</th>
            <th scope="col">Teachers</th>
            <th scope="col">Code</th>
            <th scope="col">Job</th>
            <th scope="col">Quantity of students</th>
            <th scope="col">Start date</th>
            <th scope="col">Update</th>
            <th scope="col">Delete</th>
        </tr>
        </thead>
        <tbody>
        {% for group in groups %}
            <tr>
                <th scope="row">{{ group.pk }}</th>
                <td>{{ group.name_of_curator }}</td>
                <td>{{ group.name_of_teacher }}</td>
                <td>{{ group.code_of_group }}</td>
                <td>{{ group.job }}</td>
                <td>{{ group.quantity_of_students }}</td>
                <td>{{ group.start_date }}</td>

                <th>
                    <a type="button" class="btn btn-warning" href="{% url 'groups:update_group' group.pk %}"
                    >Update</a></th>
                <th><a type="button" class="btn btn-warning" href="{% url 'groups:delete_group' group.pk %}"
                >Delete</a>
                </th>
            </tr>
        {% endfor %}

        </tbody>
    </table>
{% endblock content %}

src/templates/groups/update.html
{% extends "index.html" %}
{% load crispy_forms_tags %}

{% block content %}
    <form method='POST' style="width: 25em; margin: auto">
        {{ form|crispy }}
        <button type="submit" class="btn btn-success" value="Update">Update group</button>
    </form>
{% endblock content %}